<template>
  <div class="cont">
    <el-card class="box-card" :style="{'height':(activeName==='login'?'500px':'600px')}">
      <div class="logintitle">欢迎来到cocode！</div>
      <div class="subtitle">现在登录，打开你的全新世界</div>
      <el-tabs v-model="activeName" @tab-click="handleClick" class="tabs">
        <el-tab-pane label="登录" name="login">
          <el-input
            placeholder="用户名"
            v-model="userName"
            class="username"
            type="text"
            clearable
            :error="registerAlert"
            :error-messages="errorMessage"
          ></el-input>
          <el-input
            placeholder="密码"
            v-model="password"
            class="password"
            type="password"
            show-password
            @keyup.enter="try_login"
            :error="registerAlert"
          ></el-input>
          <el-button type="primary" @click="try_login" plain class="button">登录</el-button>
        </el-tab-pane>
        <el-tab-pane label="注册" name="register">
          <el-input
            placeholder="用户名"
            v-model.trim="register_userName"
            class="username"
            type="text"
            clearable
          ></el-input>
          <el-input
            placeholder="昵称"
            v-model.trim="register_nickName"
            class="password"
            type="text"
            clearable
          ></el-input>
          <el-input
            placeholder="密码"
            v-model.trim="register_password"
            class="password"
            type="password"
            show-password
          ></el-input>
          <el-input
            placeholder="确认密码"
            v-model.trim="register_passwordRepeat"
            @keyup.enter="register"
            :error="alert"
            :error-messages="errorMessage"
            class="password"
            type="password"
            show-password
          ></el-input>
          <el-button type="primary" @click="register" plain class="button">注册</el-button>
        </el-tab-pane>
      </el-tabs>
    </el-card>
  </div>
</template>

<script>
import hash from "../../../node_modules/sha.js";
export default {
  name: "LoginPage",
  components: {},
  computed: {
    passwordHash() {
      return hash("sha256")
        .update(this.password)
        .digest("hex");
    }
  },
  methods: {
    handleClick(tab, event) {
      console.log(tab, event);
    },
    try_login() {
      if (!this.userName.length || !this.password.length) {
        this.login_alert("用户名及密码不得为空！");
        return;
      }

      this.$axios({
        method: "post",
        url: `/login`,
        data: {
          userName: this.userName,
          password: this.passwordHash
        }
      })
        .then(res => {
          if (res.status === 200) {
            const data = res.data;
            if (data.status === "GET_SUCCESS") {
              console.log("---save seesion----", data.user);

              //将用户名和token放入sessionStorage
              sessionStorage.setItem("userName", data.user.userName);
              sessionStorage.setItem("userToken", data.user.token);
              sessionStorage.setItem("userAvatar", data.user.avatar);
              sessionStorage.setItem("userColor", data.user.color);
              sessionStorage.setItem("nickName", data.user.nickName);

              //将用户信息放入vuex
              this.$store.dispatch("setUser", data.user);

              //打印login状态
              // console.log(this.$store.state.isLogin);
              // console.log(this.$store.state.userAvatar);

              this.$router.push("/write");
              return;
            }

            if (data.status === "NAME_PASSWORD_WRONG") {
              this.login_alert("用户名或密码错误！");
            } else {
              this.login_alert("出错了！");
            }
            this.$store.dispatch("setUser", null);
          }
        })
        .catch(function(err) {
          console.log(err);
          this.login_alert("连接失败。\n请检查您的网络状态。");
          this.$store.dispatch("setUser", null);
        });
    },
    // to_register() {
    //   this.$router.push({ path: "/register" });
    //   //this.$router.push("register");
    // },
    login_alert(message) {
      this.errorMessage = "" + message;
    },
    register() {
      if (this.register_userName === "") {
        this.register_alert("用户名不能为空！");
        return;
      }

      if (this.register_userName.length > 10) {
        this.register_alert("用户名不能超过10个字符！");
        return;
      }

      if (this.register_nickName === "") {
        this.register_alert("昵称不能为空！");
        return;
      }

      if (this.register_nickName.length > 10) {
        this.register_alert("昵称不能超过10个字符！");
        return;
      }

      if (!this.register_password.length) {
        this.register_alert("密码不能为空！");
        return;
      }

      if (this.register_password.length > 20) {
        this.register_alert("密码不能超过20个字符！");
        return;
      }

      if (this.register_password !== this.passwordRepeat) {
        this.register_alert("重复密码与密码不一致！");
        return;
      }

      this.$axios({
        method: "post",
        url: `/register`,
        data: {
          userName: this.register_userName,
          password: this.register_passwordHash,
          nickName: this.register_nickName
        }
      })
        .then(res => {
          if (res.status === 200) {
            const data = res.data;
            if (data.status === "GET_SUCCESS") {
              //this.$store.dispatch('register')
              this.$router.push("/");
            } else if (data.status === "USERNAME_DUPLICATE") {
              this.register_alert("用户名已存在！");
            } else {
              this.register_alert("出错了！");
            }
          } else {
            this.register_alert("连接失败。\n请检查您的网络状态。");
          }
        })
        .catch(e => {
          this.register_alert(e);
        });
    },
    register_alert(message) {
      this.errorMessage = "" + message;
    }
  },
  beforeRouteEnter: (to, from, next) => {
    //组件内守卫
    //已登录状态回到登录界面，即 登出
    next(vm => {
      vm.$store.dispatch("setUser", null);
    });
  },
  data: () => ({
    userName: "",
    password: "",
    register_userName: "",
    register_nickName: "",
    register_password: "",
    register_passwordRepeat: "",
    registerAlert: false,
    errorMessage: "",
    activeName: "login"
  })
};
</script>

<style scoped>
.cont {
  background-color: #A0dcff;
  background-image: url(../../../public/back_ground.png);
  /* background-repeat: space; */
  height: 100%;
  width: 100%;
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
}
.a {
  top: 5%;
  position: relative;
}
.rightwrap {
  display: flex;
  justify-content: flex-end;
}
.box-card {
  width: 400px;
  height: 600px;
}
.logintitle {
  margin-top: 30px;
  margin-left: 10px;
  font-size: 26pt;
}
.subtitle {
  margin-top: 10px;
  margin-left: 12px;
  font-size: 14pt;
}
.tabs {
  margin-top: 20px;
  margin-left: 12px;
}
.tips {
  margin-left: 10px;
  margin-top: 20px;
  font-size: 16pt;
}
.username {
  margin-top: 30px;
  width: 95%;
}
.password {
  margin-top: 20px;
  width: 95%;
}
.button {
  height: 40px;
  width: 95%;
  margin-top: 45px;
}
</style>
